import { ElementRef, EventEmitter, OnDestroy, Renderer2 } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { FormControlSummary, FormControlUpdate, FormsConfig } from '../../types';
export declare const CONTROL_DIRECTIVE_SELECTOR = "ngrxFormControl";
export declare abstract class AbstractControlDirective<T> implements OnDestroy {
    protected ref: ElementRef;
    protected r2: Renderer2;
    private injectedConfig;
    controlKey?: string;
    setControlSummary: FormControlSummary<T>;
    setConfig: Partial<FormsConfig>;
    controlUpdate: EventEmitter<FormControlUpdate<T>>;
    constructor(ref: ElementRef, r2: Renderer2, injectedConfig: FormsConfig);
    private touched$;
    private value$;
    protected config$: BehaviorSubject<FormsConfig>;
    private summarySubscription;
    abstract setValue(value: T): any;
    setDisabled?(disabled: boolean): any;
    emitTouched(): void;
    emitValue(value: T): void;
    updateSummary(summary: FormControlSummary<T>): void;
    chooseClass(class1: string, class2: string, chooseSecond: boolean): void;
    ngOnDestroy(): void;
}
