import { AfterViewInit, EventEmitter, OnDestroy } from '@angular/core';
import { ReplaySubject } from 'rxjs';
import { FormArraySummary, FormArrayUpdate, FormControlUpdate, FormGroupSummary, FormGroupUpdate } from '../../types';
import { AbstractControlDirective } from '../controls/abstract-control.directive';
import { ControlChildren } from './control-children';
declare type FormSummary = FormGroupSummary<any> | FormArraySummary<any>;
declare type FormUpdate = FormGroupUpdate<any> | FormArrayUpdate<any>;
export declare abstract class AbstractFormDirective<Summary extends FormSummary, Update extends FormUpdate> extends ControlChildren implements AfterViewInit, OnDestroy {
    setFormSummary: Summary;
    formUpdate: EventEmitter<Update>;
    formSummary$: ReplaySubject<FormSummary>;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    updateChildren(children: AbstractControlDirective<any>[], summary: FormSummary): void;
    abstract emitUpdate(update: FormControlUpdate<any>, key: string): any;
}
export {};
